<?php if(!defined('IS_CMS')) die();

/***************************************************************
* 
* Eingebettete Galerie für mozilo von A. Fleischmann
* 
***************************************************************/
class PHPGallery extends Plugin {
	
	public function __construct()
	{		
		parent::__construct();
	}
	/***************************************************************
    * 
    * Gibt den HTML-Code zurück, mit dem die Plugin-Variable ersetzt 
    * wird.
    * 
    ***************************************************************/
	private $i18nPara = "";
	private $i18n = "";
	private $parameters = array();
    function getContent($value) {
		global $i18nPara, $i18n, $parameters, $HIGHLIGHT_REQUEST, $SEARCH_REQUEST;
		global $CMS_CONF;
        global $specialchars;
        global $lang_gallery_cms;
		
		#phpg|3|3|0|1|40|1|1|1|download|0|Gallerie-Name
		$parameters = array(
			"cols" => 3,
			"rows" => 3,
			"showpic" => 0,
			"preview_description_show" => 1,
			"preview_description_len" => 40,
			"curpic_description_show" => 1,
			"locator_show" => 1,
			"pic_date_show" => 1,
			"pic_link_name" => "download",
			"sort" => 0,
			"gallery_name" => "gallery name",
		);
		
        $values = explode("|", $value);
		
		global $syntax;
		if (count($values) == 1){
			$parameters["gallery_name"] = $values[0];
		}
		else{
			if (count($parameters) !=  count($values)){
				return $syntax->createDeadlink($specialchars->rebuildSpecialChars($gallery_name, false, true), $lang_gallery_cms->getLanguageValue("message_gallery_false_para_count", $specialchars->rebuildSpecialChars($gallery_name, false, true)));	
			}
			else{
				$counter =0;
				foreach ($parameters as &$value) {
					$value = $values[$counter];
					$counter ++;
				}
				
			}
		}	
		
		$gallery_name = $specialchars->replacespecialchars($specialchars->getHtmlEntityDecode($parameters["gallery_name"]),false);		
		$gallery_name_in_url ="";
		
		if (getRequestValue("gal", 'get')){
            $gallery_name_in_url = $specialchars->replacespecialchars(getRequestValue("gal", 'get'),false);			
		}
				
        $dir = PLUGIN_DIR_REL."PHPGallery/";
		$cmslanguage = $CMS_CONF->get("cmslanguage");
		
		$i18nPara = "";		
		if (isset($_GET["i18n"])){
			$cmslanguage = $_SESSION["cmslanguage"];
			$i18n = substr($cmslanguage,0,2);
			$i18nPara = "&amp;i18n=" . $i18n;			
		}		
		
		// set anchor
		$i18nPara .= "#pg_". str_replace("%20", "_", $gallery_name);
		
		
        $lang_gallery_cms = new Language($dir."sprachen/cms_language_".$cmslanguage.".txt");

        $embedded = $this->settings->get("target");
				
        $linkprefix = "index.php?cat=".CAT_REQUEST."&amp;page=".PAGE_REQUEST."&amp;";
        if ($embedded == "_blank") {
            $linkprefix = "index.php?galtemplate=true&amp;";
        }
        if($CMS_CONF->get("modrewrite") == "true") {
            $linkprefix = URL_BASE.CAT_REQUEST."/".PAGE_REQUEST.".html?";
            if ($embedded == "_blank") {
                //$linkprefix = "index.php.html?galtemplate=true&amp;";
            }
        }
    
        $index = NULL;
     
		//default
		$showpic = $parameters["showpic"];
		//url parameter
		if ( $gallery_name ===  $gallery_name_in_url){				
			$showpic = getRequestValue('showpic', 'get', true);
			$index = getRequestValue('index', 'get', true);
		}
			
        $cat_activ = "";
        if(CAT_REQUEST == basename(dirname($_SERVER['REQUEST_URI'])) and $embedded == "_self") {
            $cat_activ = "../";
        }
	
        $GALERIE_DIR = BASE_DIR.GALLERIES_DIR_NAME."/".$gallery_name."/";
        $GALERIE_DIR_SRC = str_replace("%","%25",URL_BASE.GALLERIES_DIR_NAME."/".$gallery_name."/");
    
        # keine Galerie angegeben oder Galerie gibts nicht
		
        if (($gallery_name == "") || (!file_exists($GALERIE_DIR))) {           
            if($gallery_name == "") {
                return $syntax->createDeadlink($lang_gallery_cms->getLanguageValue("message_gallerydir_error_0"),$lang_gallery_cms->getLanguageValue("message_gallerydir_error_0"));
            } else {
                return $syntax->createDeadlink($specialchars->rebuildSpecialChars($gallery_name, false, true), $lang_gallery_cms->getLanguageValue("message_gallerydir_error_1", $specialchars->rebuildSpecialChars($gallery_name, false, true)));
            }
        }
						
		$alldescriptions = false;
        if(is_file($GALERIE_DIR."texte.conf.php")){
              $alldescriptions = new Properties($GALERIE_DIR."texte.conf.php");
		}
		
				
        // Galerieverzeichnis einlesen       		
		$picarray = $this->getPicsAsArray($GALERIE_DIR);	
				
		if (count($picarray) == 0) {
			return $syntax->createDeadlink($specialchars->rebuildSpecialChars($gallery_name, false, true), $lang_gallery_cms->getLanguageValue("message_galleryempty_0", $specialchars->rebuildSpecialChars($gallery_name, false, true)));	
        }
		
        $allindexes = array();
        for ($i=1; $i<=count($picarray); $i++) {
            array_push($allindexes, $i);
        }
		
        // globaler Index
        if ((!isset($index)) || (!in_array($index, $allindexes))){
            $index = 1;
		}
        else{
            $index = $index;
		}
		
		// Bestimmung der Positionen
        $first = 1;
        $last = count($allindexes);
        if (!in_array($index-1, $allindexes)){
            $previous = $last;
		}
        else{
            $previous = $index-1;
		}
        if (!in_array($index+1, $allindexes)){
           $next = 1;
		}
        else{
            $next = $index+1;
		}		
        $html = NULL;
		
		$search = false;
		$search_phrasearray = null;
		if (ACTION_REQUEST == "search" || $HIGHLIGHT_REQUEST != "") {
			
			$search = true;
			$showpic == 0;	
			$parameters["cols"] = 1;
			$parameters["rows"] = 999;
			$tmp_search = new SearchClass();
			
			 if(strlen($HIGHLIGHT_REQUEST) > 1)
				$search_phrasearray = $tmp_search->makePhraseArray($HIGHLIGHT_REQUEST);
			else
				$search_phrasearray = $tmp_search->makePhraseArray($SEARCH_REQUEST);
			
		}
		
		if ($search){
			
			$html = $this->getThumbnailsPageSearch($picarray,$alldescriptions,$GALERIE_DIR,$GALERIE_DIR_SRC, $index, $linkprefix,$gallery_name, $search_phrasearray);
		}
		else if ( $showpic == 0){
			$html = $this->getThumbnailsPage($picarray,$alldescriptions,$GALERIE_DIR,$GALERIE_DIR_SRC, $index, $linkprefix,$gallery_name);
		}
		else if ( $showpic == 1){		
			$html = '<div id="pg_' . str_replace("%20", "_", $gallery_name) . '"><div class="phpgallery">{GALLERYMENUPICS}{CURRENTPICINPAGE}</div></div>';
			if ($parameters["curpic_description_show"] == 1){
				$html .= '<div class="picdescription">{CURRENTDESCRIPTION}</div>' ;
			}			
			$html .= '<div class="piclocator">{PICLOCATOR}</div>';
			
			$html = str_replace('{GALLERYMENUPICS}', $this->getGalleryMenuPics($picarray,$linkprefix,$gallery_name,$index,$first,$previous,$next,$last), $html);
			$html = str_replace('{CURRENTPICINPAGE}', $this->getCurrentPicInPage($picarray,$index,$GALERIE_DIR_SRC, $GALERIE_DIR, $linkprefix, $gallery_name), $html);
					
			if (count($picarray) > 0) {
				$description = $this->getCurrentDescription($picarray[$index-1],$picarray,$alldescriptions);
				$description = html_entity_decode($description, ENT_COMPAT|ENT_HTML5, CHARSET);
				$html = str_replace('{CURRENTDESCRIPTION}',$description , $html);
			} else {
				$html = str_replace('{CURRENTDESCRIPTION}', "", $html);
			}
					
			$html = str_replace('{PICLOCATOR}', $this->getPicLocator($picarray,$index,$last, $GALERIE_DIR_SRC, $GALERIE_DIR), $html);
			}
		else{
			return $syntax->createDeadlink($specialchars->rebuildSpecialChars($gallery_name, false, true), $lang_gallery_cms->getLanguageValue("message_gallery_false_start_para", $specialchars->rebuildSpecialChars($gallery_name, false, true)));
		}
		return $html;	       
    } // function getContent
    
	 // ------------------------------------------------------------------------------
    // Auslesen des übergebenen Galerieverzeichnisses, Rückgabe als Array
    // ------------------------------------------------------------------------------
    function getPicsAsArray($dir) {
		global $ALOWED_IMG_ARRAY, $parameters;
		$filetypes = $ALOWED_IMG_ARRAY;
		
		if(is_array($filetypes)){
			$filetype = array_map('strtolower', $filetypes);
		}
		
        $picarray = array();
		$tmp = array();
        $currentdir = opendir($dir);
        // Alle Dateien des übergebenen Verzeichnisses einlesen...
        while ($file = readdir($currentdir)){
            if(isValidDirOrFile($file) and (in_array(strtolower(substr($file,strrpos($file, "."))), $filetypes))) {
                // ...wenn alles passt, ans Bilder-Array anhängen
				if ($parameters["sort"] == 2){
					$tmp[filemtime($dir.$file) . $file] = $file;
				}
				else{
					$picarray[] = $file;
				}
            }
        }
        closedir($currentdir);
		if ($parameters["sort"] == 4){
			natsort ($picarray);
			$picarray = array_reverse($picarray);		
		}
		else if ($parameters["sort"] == 3){
			natsort ($picarray);			
		}
		else if ($parameters["sort"] == 2){
			ksort($tmp);
			$counter =0;
			foreach($tmp as $key=>$value){
				$picarray[$counter] = $value;
				$counter ++;
			}
			$picarray = array_reverse($picarray);
		}
		else if ($parameters["sort"] == 1){
			rsort($picarray);
		}
		else{
			sort($picarray);
		}
        		
        return $picarray;
    }
	

	function getPicLocator($picarray,$index,$last, $GALERIE_DIR_SRC, $GALERIE_DIR){
		global $parameters, $specialchars;
		
		$result = "";
		$filename = $specialchars->replaceSpecialChars($picarray[$index-1], true);
		
		if ($parameters["locator_show"] == 1){
			$result .= $this->getXoutofY($picarray,$index,$last);
		}
		
		if ($parameters["pic_date_show"] == 1){
			$result .= ($result!="")? " - ": "";
			$picdate = "";			
			if (file_exists($GALERIE_DIR . "original/" . $filename)){
				$picdate = date ("d.m.Y", filemtime($GALERIE_DIR . "original/" . $filename));
			}
			else{
				$picdate = date ("d.m.Y", filemtime($GALERIE_DIR.$filename));
			}
			$result .= $picdate;
		}
		
		if ($parameters["pic_link_name"] != ""){				 
			if (file_exists($GALERIE_DIR . "original/" . $filename)){
				$result .= ($result!="")? " - ": "";
				$result .= "<a target=\"_blank\" href=\"". $GALERIE_DIR_SRC . "original/" . $filename ."\" >".$parameters["pic_link_name"]."</a>";
			}
		}
		return $result;
	}
    // ------------------------------------------------------------------------------
    // Galeriemenü erzeugen
    // ------------------------------------------------------------------------------
    function getGalleryMenu($picarray,$linkprefix,$gallery_name,$index,$first,$previous,$next,$last) {
        global $lang_gallery_cms;
    
        // Keine Bilder im Galerieverzeichnis?
        if (count($picarray) == 0)
            return "&nbsp;";

        $gallerymenu = "<ul class=\"gallerymenu\">";
    
        // Link "Erstes Bild"
        if ($index == $first)
            $linkclass = "gallerymenuactive";
        else
            $linkclass = "gallerymenu";
        $gallerymenu .= "<li class=\"gallerymenu\"><a href=\"".$linkprefix."gal=".$gallery_name."&amp;index=".$first."\" class=\"$linkclass\">".$lang_gallery_cms->getLanguageValue("message_firstimage_0")."</a></li>";
        // Link "Voriges Bild"
        $gallerymenu .= "<li class=\"gallerymenu\"><a class=\"prev\" href=\"".$linkprefix."gal=".$gallery_name."&amp;index=".$previous."\" class=\"gallerymenu\">".$lang_gallery_cms->getLanguageValue("message_previousimage_0")."</a></li>";
        // Link "Nächstes Bild"
        $gallerymenu .= "<li class=\"gallerymenu\"><a class=\"next\" href=\"".$linkprefix."gal=".$gallery_name."&amp;index=".$next."\" class=\"gallerymenu\">".$lang_gallery_cms->getLanguageValue("message_nextimage_0")."</a></li>";
        // Link "Letztes Bild"
        if ($index == $last)
            $linkclass = "gallerymenuactive";
        else
            $linkclass = "gallerymenu";
        $gallerymenu .= "<li class=\"gallerymenu\"><a href=\"".$linkprefix."gal=".$gallery_name."&amp;index=".$last."\" class=\"$linkclass\">".$lang_gallery_cms->getLanguageValue("message_lastimage_0")."</a></li>";
        // Rückgabe des Menüs
        return $gallerymenu."</ul>";
    }
	
	
	// ------------------------------------------------------------------------------
    // Galeriemenü -Previous Preview Next erzeugen
    // ------------------------------------------------------------------------------
    function getGalleryMenuPics($picarray,$linkprefix,$gallery_name,$index,$first,$previous,$next,$last) {
        global $lang_gallery_cms, $i18nPara;
    
        // Keine Bilder im Galerieverzeichnis?
        if (count($picarray) == 0)
            return "&nbsp;";
		
        $gallerymenupics = "<ul class=\"phpgalleryarrows\" >\n";	  
        						
		// Link "Voriges Bild"
		$img = '<img src="'.URL_BASE.PLUGIN_DIR_NAME.'/PHPGallery/images/prev.png" title="' .$lang_gallery_cms->getLanguageValue("message_previousimage_0"). '" alt="' .$lang_gallery_cms->getLanguageValue("message_previousimage_0"). '"/>';
		
        $gallerymenupics .= "<li class=\"phpgalleryarrows\">\n<a href=\"".$linkprefix."gal=".$gallery_name."&amp;index=".$previous . "&amp;showpic=1" . $i18nPara . "\" >".$img."</a>\n</li>\n";
						
		//preview	
		$img = '<img src="'.URL_BASE.PLUGIN_DIR_NAME.'/PHPGallery/images/up.png" title="' .$lang_gallery_cms->getLanguageValue("preview"). '" alt="' .$lang_gallery_cms->getLanguageValue("preview"). '"/>';
		
		$gallerymenupics .= "<li class=\"phpgalleryarrows\">\n<a href=\"".$linkprefix."gal=".$gallery_name."&amp;index=".$index . "&amp;showpic=0" . $i18nPara ."\" >".$img."</a>\n</li>\n";
				
        // Link "Nächstes Bild"
		$img = '<img src="'.URL_BASE.PLUGIN_DIR_NAME.'/PHPGallery/images/next.png" title="' .$lang_gallery_cms->getLanguageValue("message_nextimage_0"). '" alt="' .$lang_gallery_cms->getLanguageValue("message_nextimage_0"). '"/>';
        
		$gallerymenupics .= "<li class=\"phpgalleryarrows\">\n<a href=\"".$linkprefix."gal=".$gallery_name."&amp;index=".$next . "&amp;showpic=1" . $i18nPara . "\" >".$img. "</a>\n</li>\n";
       
	   $gallerymenupics .= "</ul>\n";
      
        return $gallerymenupics;
    }
    // ------------------------------------------------------------------------------
    // Nummernmenü erzeugen
    // ------------------------------------------------------------------------------
    function getNumberMenu($picarray,$linkprefix,$index,$gallery_name,$first,$last) {
    
        // Keine Bilder im Galerieverzeichnis?
        if (count($picarray) == 0)
            return "&nbsp;";
    
        $numbermenu = "<ul class=\"gallerynumbermenu\">";
        for ($i=$first; $i<=$last; $i++) {
            $cssclass = $index == $i ? "gallerynumbermenuactive" : "gallerynumbermenu";
            $numbermenu .= "<li class=\"gallerynumbermenu\">"
                ."<a href=\"".$linkprefix."gal=".$gallery_name."&amp;index=".$i."\" class=\"".$cssclass."\">".$i."</a>"
        ."</li>";
        }
        // Rückgabe des Menüs
        $numbermenu .= "</ul>";
        return $numbermenu;
    }

    
	 // ------------------------------------------------------------------------------
    // Preview Page für Suche / Highlight erzeugen
    // ------------------------------------------------------------------------------
    function getThumbnailsPageSearch($picarray,$alldescriptions,$GALERIE_DIR,$GALERIE_DIR_SRC, $index, $linkprefix,$gallery_name, $search_phrasearray) {
        global $specialchars, $lang_gallery_cms, $i18nPara , $parameters;
  		$short_description = false;
		
		if ($index > count($picarray)) {$index = count($picarray);}
				
        $picsperrow = $parameters["cols"]; 
        #if (empty($picsperrow)) $picsperrow = 3;
		
		$picsrows =  $parameters["rows"]; 
        #if (empty($picsrows)) $picsrows = 3;
		
		//how many pics on page
		$pagepics = $picsperrow * $picsrows;
		//how many pages
		$modulo = count($picarray) % $pagepics;
		$pagescount = ($modulo == 0)? count($picarray) / $pagepics: ((count($picarray) - $modulo) / $pagepics) +1;
					
		//get pics page
		$pagestart = 0;
		$lastpageno = 0;				
		//get pagestart
		for ($i = 0; $i < count($picarray); $i += $pagepics)
		{	
			$lastpageno	= $i;				
			if ( (($index-1)>= $i) &&  (($index-1)< ($i+$pagepics))){							
				$pagestart = $i;
				//break;
			}					
		}	
		
		$pageend = $pagestart+$pagepics;
		if ($pageend > count($picarray)){$pageend = count($picarray);}
		
		$menu= "";
				
		$menu .= "<td colspan=" . $picsperrow . " class=\"phpgallerypagesmenu\" style=\"width:100%;\">&nbsp;</td>\n";
			
		
		// thumbs
        $thumbs = "<div id=\"pg_" . str_replace("%20", "_", $gallery_name) . "\"><table class=\"phpgallerytable\" summary=\"gallery table\">\n";
        $thumbs .= "<tr>\n" . $menu . "<tr>\n";
		$tmp_search = new SearchClass();
		
        for ($i = $pagestart; $i < $pageend; $i++) {
            // Bildbeschreibung holen
			$showthumb = false;
			
			$description = $this->getCurrentDescription($picarray[$i],$picarray,$alldescriptions, $short_description);
			$description = html_entity_decode($description, ENT_COMPAT|ENT_HTML5, CHARSET);
			
			foreach($search_phrasearray as $phrase) {
                if($phrase == "")
                    continue;
				
                if(substr_count($tmp_search->lowercase($description), $phrase) > 0){
                  $showthumb = true;
				  break;
                }
            }
			
			if ($showthumb){		
				// Neue Tabellenzeile aller picsperrow Zeichen
				if (($i > $pagestart) && ($i % $picsperrow == 0))
					$thumbs .= "</tr>\n<tr>\n";
				$thumbs .= "<td class=\"phpgallerytd\" style=\"width:".floor(100 / $picsperrow)."%;\">";

				if (file_exists($GALERIE_DIR.PREVIEW_DIR_NAME."/".$specialchars->replaceSpecialChars($picarray[$i],false))) {
					$src =  $linkprefix . "gal=" . $gallery_name . "&amp;index=" . ($i +1) . "&amp;showpic=1". $i18nPara ;
					$thumbs .= "<a href=\"".$src."\"  title=\"".$lang_gallery_cms->getLanguageValue("tooltip_gallery_fullscreen_1", $specialchars->rebuildSpecialChars($picarray[$i],true,true))."\"><img src=\"".$GALERIE_DIR_SRC.PREVIEW_DIR_NAME."/".$specialchars->replaceSpecialChars($picarray[$i],true)."\" alt=\"".$specialchars->rebuildSpecialChars($picarray[$i],true,true)."\" class=\"thumbnailphp\" /></a><br />";
				} else {
					 $thumbs .= '<div style="text-align:center;"><a style="color:red;" href="'.$GALERIE_DIR_SRC.PREVIEW_DIR_NAME."/".$specialchars->replaceSpecialChars($picarray[$i],true).'" title="'.$lang_gallery_cms->getLanguageValue("tooltip_gallery_fullscreen_1", $specialchars->rebuildSpecialChars($picarray[$i],true,true)).'"><b>'.$lang_gallery_cms->getLanguageValue('message_gallery_no_preview').'</b></a></div>';
				}
				$thumbs .= $description
				."</td>\n";
			}
        }
        while ($i % $picsperrow > 0) {
            $thumbs .= "<td class=\"phpgallerytd\">&nbsp;</td>\n";
            $i++;
        }
        $thumbs .= "</tr>\n</table></div>";
        // Rückgabe der Thumbnails
        return $thumbs;
    }	
	 // ------------------------------------------------------------------------------
    // Preview Page erzeugen
    // ------------------------------------------------------------------------------
    function getThumbnailsPage($picarray,$alldescriptions,$GALERIE_DIR,$GALERIE_DIR_SRC, $index, $linkprefix,$gallery_name) {
        global $specialchars, $lang_gallery_cms, $i18nPara , $parameters;
		
  		$short_description = true;
		
		if ($index > count($picarray)) {$index = count($picarray);}
				
        $picsperrow = $parameters["cols"]; 
     
		$picsrows =  $parameters["rows"]; 
      
		//how many pics on page
		$pagepics = $picsperrow * $picsrows;
		//how many pages
		$modulo = count($picarray) % $pagepics;
		$pagescount = ($modulo == 0)? count($picarray) / $pagepics: ((count($picarray) - $modulo) / $pagepics) +1;
					
		//get pics page
		$pagestart = 0;
		$lastpageno = 0;				
		//get pagestart
		for ($i = 0; $i < count($picarray); $i += $pagepics)
		{	
			$lastpageno	= $i;				
			if ( (($index-1)>= $i) &&  (($index-1)< ($i+$pagepics))){							
				$pagestart = $i;
				//break;
			}					
		}	
		
		$pageend = $pagestart+$pagepics;
		if ($pageend > count($picarray)){$pageend = count($picarray);}
		
		$menu= "";
		if ($pagescount > 1){
			//get middle links menu
			$separator = 0;
			$pageslinks = "";
			
			$count = 0;
			$dummies = 0;
			if($pagescount > 3) {
				if ($pagescount == 4){
					$dummies = 1;
				}
				else{
					$dummies = 2;
				}
			}
			$addeddummies = 0;
			for ($i = 0; $i < count($picarray); $i += $pagepics)
			{
				$insertlink = false;
				$count++; 				
				$src = $linkprefix . "gal=" . $gallery_name . "&amp;index=" . ($i +1) . "&amp;showpic=0" . $i18nPara;
				
				if ( $i == $pagestart){						
					//active
					$pageslinks .= "<span>" . $count . "</span>" ;					
				}
				else if ( $i == 0 || $i == $lastpageno ){
					//first or last
					$insertlink = true;
				}
				else  if  ($pagestart == 0 && $i == $pagepics) {
					//after first
					$insertlink = true;
				}
				else if ($i + $pagepics == $lastpageno && $pagestart == $lastpageno)
				{
					//before last
					$insertlink = true;
				}
				else{
					//dummies
					if ($addeddummies < $dummies)	{
						$add = false;
						if ($addeddummies == 0){
							$add = true;
						}
						else if($i > $pagestart){
							$add = true;
						}
						else if($count == $pagescount -2){
							$add = true;
						}
						
						if ($add){
							$pageslinks .= "<span>.</span>" ;
							$addeddummies++;
						}
					}					
				}
				
				if ($insertlink == true){
				
					$pageslinks .="<a href=\"".$src."\"  title=\"" . $count . "\">" . $count . "</a>";
				}
							
			}		
													
			$indexPrevPage = (($pagestart-$pagepics )>= 0)?$pagestart- $pagepics +1 :count($picarray);
			$indexNextPage = (($pagestart + $pagepics + 1)<= count($picarray))?$pagestart + $pagepics + 1:1;
			// menu previous next
			$menu = "";
			
			//arrow previous
			$imgprev = '<img src="'.URL_BASE.PLUGIN_DIR_NAME.'/PHPGallery/images/prev.png" title="' .$lang_gallery_cms->getLanguageValue("message_previouspage"). '" alt="' .$lang_gallery_cms->getLanguageValue("message_previouspage"). '"/>';
			
			//arrow next
			$imgnext = '<img src="'.URL_BASE.PLUGIN_DIR_NAME.'/PHPGallery/images/next.png" title="' .$lang_gallery_cms->getLanguageValue("message_nextpage"). '" alt="' .$lang_gallery_cms->getLanguageValue("message_nextpage"). '"/>';
			
			$menu .= "<td colspan=" . $picsperrow . " class=\"phpgallerypagesmenu\" style=\"width:100%;\">";
			for ($i = 0; $i < 3; $i++){
				
				
				if ($i ==0){
					$src =  $linkprefix . "gal=" . $gallery_name . "&amp;index=" . $indexPrevPage . "&amp;showpic=0" . $i18nPara;
					$menu .= "<a class=\"prevnavarrow\" href=\"".$src."\"  title=\"previous\"> " . $imgprev . " </a>";
				}
				else if ($i==1){
					$menu .= $pageslinks;
				}
				else if ($i==2){
					$src =  $linkprefix . "gal=" . $gallery_name . "&amp;index=" . $indexNextPage . "&amp;showpic=0" . $i18nPara;
					$menu .= "<a class=\"prevnavarrow\" href=\"".$src."\"  title=\"next\">" . $imgnext . "</a>";
				}
				
			}
			$menu .= "</td>\n";
		} // menu only for $pagescount > 1
		else{
			$menu .= "<td colspan=" . $picsperrow . " class=\"phpgallerypagesmenu\" style=\"width:100%;\">&nbsp;</td>\n";
		}
		
		
		// thumbs
        $thumbs = "<div id=\"pg_" . str_replace("%20", "_", $gallery_name) . "\"><table class=\"phpgallerytable\" summary=\"gallery table\">\n";
        $thumbs .= "<tr>\n" . $menu . "<tr>\n";
		$description =''; 
        for ($i = $pagestart; $i < $pageend; $i++) {
            // Bildbeschreibung holen
			if ($parameters["preview_description_show"] == 1){
				$description = $this->getCurrentDescription($picarray[$i],$picarray,$alldescriptions, $short_description);
				$description = $this->getCurrentDescription($picarray[$i],$picarray,$alldescriptions, $short_description);
				$description = html_entity_decode($description, ENT_COMPAT|ENT_HTML5, CHARSET);
				if ($description == ""){
					$description = "&nbsp;";
				}
			}
            // Neue Tabellenzeile aller picsperrow Zeichen
            if (($i > $pagestart) && ($i % $picsperrow == 0))
                $thumbs .= "</tr>\n<tr>\n";
            $thumbs .= "<td class=\"phpgallerytd\" style=\"width:".floor(100 / $picsperrow)."%;\">";

            if (file_exists($GALERIE_DIR.PREVIEW_DIR_NAME."/".$specialchars->replaceSpecialChars($picarray[$i],false))) {
				$src =  $linkprefix . "gal=" . $gallery_name . "&amp;index=" . ($i +1) . "&amp;showpic=1". $i18nPara ;
                $thumbs .= "<a href=\"".$src."\"  title=\"".$lang_gallery_cms->getLanguageValue("tooltip_gallery_fullscreen_1", $specialchars->rebuildSpecialChars($picarray[$i],true,true))."\"><img src=\"".$GALERIE_DIR_SRC.PREVIEW_DIR_NAME."/".$specialchars->replaceSpecialChars($picarray[$i],true)."\" alt=\"".$specialchars->rebuildSpecialChars($picarray[$i],true,true)."\" class=\"thumbnailphp\" /></a><br />";
            } else {
                 $thumbs .= '<div style="text-align:center;"><a style="color:red;" href="'.$GALERIE_DIR_SRC.PREVIEW_DIR_NAME."/".$specialchars->replaceSpecialChars($picarray[$i],true).'" title="'.$lang_gallery_cms->getLanguageValue("tooltip_gallery_fullscreen_1", $specialchars->rebuildSpecialChars($picarray[$i],true,true)).'"><b>'.$lang_gallery_cms->getLanguageValue('message_gallery_no_preview').'</b></a></div>';
            }
            $thumbs .= $description
            ."</td>\n";
        }
        while ($i % $picsperrow > 0) {
            $thumbs .= "<td class=\"phpgallerytd\">&nbsp;</td>\n";
            $i++;
        }
        $thumbs .= "</tr>\n</table></div>";
        // Rückgabe der Thumbnails
        return $thumbs;
    }
    // ------------------------------------------------------------------------------
    // Aktuelles Bild anzeigen
    // ------------------------------------------------------------------------------
    function getCurrentPic($picarray,$index,$GALERIE_DIR_SRC) {
        global $specialchars;
        global $lang_gallery_cms;
   
        // Keine Bilder im Galerieverzeichnis?
        if (count($picarray) == 0)
            return "&nbsp;";
        // Link zur Vollbildansicht öffnen
		$currentpic = ""; //"<div class=\"curpic\">";
        $currentpic .= "<a href=\"".$GALERIE_DIR_SRC.$specialchars->replaceSpecialChars($picarray[$index-1],true)."\" target=\"_blank\" title=\"".$lang_gallery_cms->getLanguageValue("tooltip_gallery_fullscreen_1", $specialchars->rebuildSpecialChars($picarray[$index-1],true,true))."\">";
        $currentpic .= "<img src=\"".$GALERIE_DIR_SRC.$specialchars->replaceSpecialChars($picarray[$index-1],true)."\" alt=\"".$lang_gallery_cms->getLanguageValue("alttext_galleryimage_1", $specialchars->rebuildSpecialChars($picarray[$index-1],true,true))."\" />";        
		// Link zur Vollbildansicht schliessen
        $currentpic .= "</a>";
		#$currentpic = "</div>";
        // Rückgabe des Bildes
        return $currentpic;
    }
	
	// ------------------------------------------------------------------------------
    // Aktuelles Bild anzeigen
    // ---
	function getCurrentPicInPage($picarray, $index, $GALERIE_DIR_SRC, $GALERIE_DIR, $linkprefix, $gallery_name) {
        global $specialchars;
        global $lang_gallery_cms, $i18nPara;
		
		
		// Keine Bilder im Galerieverzeichnis?
        if (count($picarray) == 0)
            return "&nbsp;";
		
		$filename = $specialchars->replaceSpecialChars($picarray[$index-1], true);
		
		$indexPrev = (($index-2)>= 0)?$index-1:count($picarray);
		$indexNext = (($index)< count($picarray))?$index +1:1;
						
		list($width, $height) = getimagesize($GALERIE_DIR.$filename);
		
		$currentpic = "<map name=\"map_" .$gallery_name . "\"  class=\"prevnext\">\n";

		// shape previous
		$coords = "0,0," . floor($width / 2) . "," . $height;
		$widthleft = floor($height * 35 /100); //35%
		$coords = "0,0," . $widthleft ."," . $height;
		
		$currentpic .= "<area  shape=\"rect\" coords=\"" . $coords . "\" href=\"" . $linkprefix . "gal=" . $gallery_name . "&amp;index=" . $indexPrev . "&amp;showpic=1" . $i18nPara  . "\"";			
		$currentpic .= " alt=\"\" title=\"" . $lang_gallery_cms->getLanguageValue("message_previousimage_0") . "\" >\n";
		

		//shape next
		$coords = ceil($width / 2) . ",0," . $width . "," . $height;
		$coords =  $widthleft . ",0," . $width . "," . $height;
		
		$currentpic .= "<area  shape=\"rect\" coords=\"" . $coords . "\" href=\"" . $linkprefix . "gal=" . $gallery_name  . "&amp;index=" . $indexNext . "&amp;showpic=1" . $i18nPara . "\"";			
		$currentpic .= " alt=\"\" title=\"" . $lang_gallery_cms->getLanguageValue("message_nextimage_0") . "\" >\n";

		$currentpic .= "</map>\n";
		$currentpic .= "<img  class=\"currpic\" alt=\"\" src=\"" . $GALERIE_DIR_SRC  . $filename . "\" width=\"" . $width ."\"  usemap=\"#map_" .$gallery_name . "\" />\n";
		
		#$currentpic .= "<div style=\"position: absolute; top: 0; left:0;background-image: url(/n.gif)\">";
        // Rückgabe des Bildes
        return $currentpic;
    }
    // ------------------------------------------------------------------------------
    // Beschreibung zum aktuellen Bild anzeigen
    // ------------------------------------------------------------------------------
    function getCurrentDescription($picname,$picarray,$alldescriptions, $short = false) {
        global $specialchars, $parameters;
        if(!$alldescriptions)
           return "&nbsp;";
        // Keine Bilder im Galerieverzeichnis?
        if (count($picarray) == 0)
           return "&nbsp;";
        // Bildbeschreibung einlesen
        $description = $alldescriptions->get($picname);
		
		$tmp_syntax = new Syntax();     
		$description = $tmp_syntax->convertContent($description, true);
        if(strlen($description) > 0) {
		
				if ($short){
					$description = $specialchars->rebuildSpecialChars($description,false,true);
			
					if (strlen($description) > $parameters["preview_description_len"]){
						$description = substr($description, 0, $parameters["preview_description_len"]) . "...";
					}					
					return $description;
				}
				else{
					return $specialchars->rebuildSpecialChars($description,false,true);
				}
        } else {
            return "&nbsp;";
        }
    }
	
	
	// function getDescriptiontranslated($description){
		// global $i18n;
		// $result = $description;
		// if (strpos($description, "{i18n|",0) !== false)
		// {
			// $result =  "&nbsp;";
			// $pos = strpos( "{i18n|" . $i18n, 0);
			// if (!$pos !== false){
				// $pos += 9;
				// $posend = strpos($description, "}", $pos);				
				// if ($posend !== false){
					// $result = substr($description, $pos, $posend - $pos);
				// }
			// }
		// }
		// return $result;
	// }
    // ------------------------------------------------------------------------------
    // Position in der Galerie anzeigen
    // ------------------------------------------------------------------------------
    function getXoutofY($picarray,$index,$last) {
        global $lang_gallery_cms;
    
        // Keine Bilder im Galerieverzeichnis?
        if (count($picarray) == 0)
        return "&nbsp;";
        return $lang_gallery_cms->getLanguageValue("message_gallery_xoutofy_2", $index, $last);
    }


    // ------------------------------------------------------------------------------
    // Hilfsfunktion: "title"-Attribut zusammenbauen (oder nicht, wenn nicht konfiguriert)
    // ------------------------------------------------------------------------------
    /*
    function getTitleAttribute($value) {
        global $CMS_CONF;
        if ($CMS_CONF->get("showsyntaxtooltips") == "true") {
            return " title=\"".$value."\"";
        }
        return "";
    }*/

    /***************************************************************
    * 
    * Gibt die Konfigurationsoptionen als Array zurück.
    * 
    ***************************************************************/
    function getConfig() {
        global $lang_gallery_admin;

        // Rückgabe-Array initialisieren
        // Das muß auf jeden Fall geschehen!
        $config = array();
      
       
        return $config;
    } // function getConfig    
    
    
    /***************************************************************
    * 
    * Gibt die Plugin-Infos als Array zurück
    *  
    ***************************************************************/
    
    
    function getInfo() {

        global $ADMIN_CONF;
        global $lang_gallery_admin;

        $dir = PLUGIN_DIR_REL."PHPGallery/";
        $language = $ADMIN_CONF->get("language");
        $lang_gallery_admin = new Properties($dir."sprachen/admin_language_".$language.".txt",false);
//         if(!isset($lang_gallery_admin->properties['readonly'])) {
//             die($lang_gallery_admin->properties['error']);
//         }

        $info = array(
            // Plugin-Name
            "<b>".$lang_gallery_admin->get("config_gallery_plugin_name")."</b> \$ 0.94 $",
            // CMS-Version
            "2.0 / 2.1",
            // Kurzbeschreibung
            $lang_gallery_admin->get("config_gallery_plugin_desc"),
            // Name des Autors
           "Aurel Fleischmann",
            // Download-URL
            "http://www.mozilo.de",
            # Platzhalter => Kurzbeschreibung			
            array('{PHPGallery|...}' => $lang_gallery_admin->get("config_gallery_plugin"),'{PHPGallery|3|3|0|1|40|1|1|1|download|0|...}' => $lang_gallery_admin->get("config_gallery_plugin_parameters"))
            );
            return $info;
    } // function getInfo

} // class plugin

?>
